#include once "fbgfx.bi"
#include once "horde3d.bi"

function InitHorde3D(byval w as integer=640,byval h as integer=480) as boolean
  dim as integer bits
  screeninfo ,,bits
  ' create window with OpenGL context
  screenres w,h,bits,,fb.GFX_OPENGL
  if screenptr()=0 then
    screen 0
    print "error: init OpenGL context !"
    beep : sleep : end 1
  end if
  flip
  ' init Horde3D
  var ret = h3dInit()
  if ret=false then h3dutDumpMessages()
  return ret
end function

if InitHorde3D()=false then
  screen 0
  print "error: init Horde3D !"
  beep:sleep:end
end if
' get current screen size
dim as integer w,h
screeninfo w,h

dim as string dumpFile  = command(0) & ".html"
dim as string dumpTitle = "Infobox test with: " & *h3dGetVersionString
h3dutSetDumpFile (strptr(dumpFile))
h3dutSetDumpTitle(strptr(dumpTitle))

' Load resources
var forwardPipeRes = h3dAddPipeline("pipelines/forward.pipeline.xml")
var fontMatRes     = h3dAddMaterial("overlays/font.material.xml")
var panelMatRes    = h3dAddMaterial("overlays/panel.material.xml")
var contentDir = exepath() + "/Content"
h3dutLoadResourcesFromDisk(strptr(contentDir))

' Add camera
var cam = h3dAddCameraNode(H3DRootNode, "Camera", forwardPipeRes)

' Setup viewport and render target sizes
h3dSetNodeParamI( cam, H3DCamera_ViewportWidthI, w )
h3dSetNodeParamI( cam, H3DCamera_ViewportHeightI, h)

' Set camera parameters (pos, rotation, scale)
h3dSetNodeTransform(cam, 0,0,0, 0,0,0, 1,1,1)

' Set camera parameters (fov,  ratio, near, far)
h3dSetupCameraView( cam, 45.0, w / h, 0.1, 1000.0 )
h3dResizePipelineBuffers( forwardPipeRes, w, h )

const as integer NROWS = 2
dim as zstring ptr labels(NROWS-1) => {@"value",@"text"}
dim as zstring ptr values(NROWS-1) => {@"1.23",@"off"}

while inkey()=""
  h3dClearOverlays()
  h3dutShowInfoBox(0.25,0.25,.25,"Title",NROWS,@labels(0),@values(0),fontMatRes,panelMatRes)
  h3dRender( cam )
  h3dFinalizeFrame()
  flip
wend

' free all resources
h3dRelease()
