#include once "fbgfx.bi"
#include once "horde3d.bi"

function InitHorde3D(w as integer=640,h as integer=480) as boolean
  dim as integer bits
  screeninfo ,,bits
  ' create OpenGL context
  screenres w,h,bits,,fb.GFX_OPENGL
  flip
  ' init Horde3D
  return h3dInit()
end function

if InitHorde3D()=false then
  screen 0
  print "error: init Horde3D !"
  beep:sleep:end
end if
dim as string dumpFile  = command(0) & ".html"
dim as string dumpTitle = "Terrain test with: " & *h3dGetVersionString
h3dutSetDumpFile (strptr(dumpFile))
h3dutSetDumpTitle(strptr(dumpTitle))


' get current screen size
dim as integer w,h
screeninfo w,h

' Add resources
var forwardPipeRes = h3dAddPipeline("pipelines/forward.pipeline.xml")
var terrainRes     = h3dAddSceneGraph("terrains/terrain1/terrain1.scene.xml")
' Load resources
var contentDir = exepath() + "/Content"
h3dutLoadResourcesFromDisk(strptr(contentDir))
h3dutDumpMessages()

' Add scene nodes

' Add Camera
var cam     = h3dAddCameraNode(H3DRootNode, "Camera", forwardPipeRes)
' Add Terrain
var terrain = h3dAddNodes(H3DRootNode, terrainRes)

' Setup viewport and render target sizes
h3dSetNodeParamI(cam, H3DCamera_ViewportXI     , 0)
h3dSetNodeParamI(cam, H3DCamera_ViewportYI     , 0)
h3dSetNodeParamI(cam, H3DCamera_ViewportWidthI , w)
h3dSetNodeParamI(cam, H3DCamera_ViewportHeightI, h)

' Set camera parameters (fov,  ratio, near, far)
h3dSetupCameraView(cam, 45.0, w / h, 0.1, 2000.0)
h3dResizePipelineBuffers(forwardPipeRes, w, h)

' Set camera parameters (pos, rotation, scale)
h3dSetNodeTransform(cam, 512,120,512, 0,225,0, 1,1,1)

' Set sun direction for ambient pass
var matRes = h3dFindMaterial("terrains/terrain1/terrain1.material.xml" )

h3dutDumpMessages()

' h3dSetOption(H3DOptions_DebugViewMode,1)
' h3dSetOption(H3DOptions_WireframeMode,1)
dim as double t
while inkey()=""
  h3dSetMaterialUniform( matRes, "sunDir", sin(t),-1,0, cos(t))
  ' Render scene
  h3dRender( cam )
  ' Finish rendering of frame
  h3dFinalizeFrame()
  ' swap buffers
  flip
  t+=0.01
wend

' free all resources
h3dRelease()
